﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Services;
using System.Runtime.Serialization;
using System.Collections.ObjectModel;

namespace ServerSideFilteringSL.Web
{
    /// <summary>
    /// Summary description for DataWebService
    /// </summary>
    [WebService(Namespace = "http://tempuri.org/")]
    [WebServiceBinding(ConformsTo = WsiProfiles.BasicProfile1_1)]
    [System.ComponentModel.ToolboxItem(false)]
    // To allow this Web Service to be called from script, using ASP.NET AJAX, uncomment the following line. 
    // [System.Web.Script.Services.ScriptService]
    public class DataWebService : System.Web.Services.WebService
    {
        public static List<ServerPerson> CurrentDataSource;

       

        [WebMethod]
        public List<ServerPerson> GetCurrentDataSource(int pagesize)
        {
            List<ServerPerson> _listperson = new List<ServerPerson>();
            if (CurrentDataSource==null)
            {
                CurrentDataSource = DataGenerators.GetCustomerList(100);
               

                for (int i = 0; i < pagesize; i++)
                {
                    _listperson.Add(CurrentDataSource[i]);
                }
                return _listperson;
            }
            else
            {
              
                for (int i = 0; i < pagesize; i++)
                {
                    _listperson.Add(CurrentDataSource[i]);
                 }
                return _listperson; 
            }
            return null;
        }

        [WebMethod]
        public List<ServerPerson> GetTextFilteredDataFromServer(string FilterOperation, string filterstring, string columnname)
        {
              switch (FilterOperation)
            {
                case "Contains":
                    return (from person in CurrentDataSource where person.GetType().GetProperty(columnname).GetValue(person, null).ToString().ToLower().Contains(filterstring.ToLower())   select person).ToList<ServerPerson>();

                case "Starts with":
                    return (from person in CurrentDataSource where person.GetType().GetProperty(columnname).GetValue(person, null).ToString().ToLower().StartsWith(filterstring.ToLower()) select person).ToList<ServerPerson>();

                case "Equals":
                    return (from person in CurrentDataSource where person.GetType().GetProperty(columnname).GetValue(person, null).ToString().ToLower().Equals(filterstring.ToLower()) select person).ToList<ServerPerson>();

                case "Not Equals":
                    return (from person in CurrentDataSource where !person.GetType().GetProperty(columnname).GetValue(person, null).ToString().ToLower().Equals(filterstring.ToLower()) select person).ToList<ServerPerson>();
            }
            return null;
        }


        [WebMethod]
        public List<ServerPerson> GetNumericFilteredDataFromServerOrComb(string FilterOperations, string filtervalues, string columnname)
        {
            string[] values = filtervalues.Split('|');

            switch (FilterOperations)
            {
                case "Equals|Equals":
                    return (from person in CurrentDataSource where double.Parse(person.GetType().GetProperty(columnname).GetValue(person, null).ToString()) == double.Parse(values[0]) || double.Parse(person.GetType().GetProperty(columnname).GetValue(person, null).ToString()) == double.Parse(values[1]) select person).ToList<ServerPerson>();

                case "Equals|Greater":
                    return (from person in CurrentDataSource where double.Parse(person.GetType().GetProperty(columnname).GetValue(person, null).ToString()) == double.Parse(values[0]) || double.Parse(person.GetType().GetProperty(columnname).GetValue(person, null).ToString()) > double.Parse(values[1]) select person).ToList<ServerPerson>();

                case "Equals|Greater/Equals":
                    return (from person in CurrentDataSource where double.Parse(person.GetType().GetProperty(columnname).GetValue(person, null).ToString()) == double.Parse(values[0]) || double.Parse(person.GetType().GetProperty(columnname).GetValue(person, null).ToString()) >= double.Parse(values[1]) select person).ToList<ServerPerson>();

                case "Equals|Less":
                    return (from person in CurrentDataSource where double.Parse(person.GetType().GetProperty(columnname).GetValue(person, null).ToString()) == double.Parse(values[0]) || double.Parse(person.GetType().GetProperty(columnname).GetValue(person, null).ToString()) < double.Parse(values[1]) select person).ToList<ServerPerson>();

                case "Equals|Less/Equals":
                    return (from person in CurrentDataSource where double.Parse(person.GetType().GetProperty(columnname).GetValue(person, null).ToString()) == double.Parse(values[0]) || double.Parse(person.GetType().GetProperty(columnname).GetValue(person, null).ToString()) <= double.Parse(values[1]) select person).ToList<ServerPerson>();
              
                case "Equals|Not Equals":
                    return (from person in CurrentDataSource where double.Parse(person.GetType().GetProperty(columnname).GetValue(person, null).ToString()) == double.Parse(values[0]) || double.Parse(person.GetType().GetProperty(columnname).GetValue(person, null).ToString()) != double.Parse(values[1]) select person).ToList<ServerPerson>();
               
                case "Greater|Greater":
                    return (from person in CurrentDataSource where double.Parse(person.GetType().GetProperty(columnname).GetValue(person, null).ToString()) > double.Parse(values[0]) || double.Parse(person.GetType().GetProperty(columnname).GetValue(person, null).ToString()) > double.Parse(values[1]) select person).ToList<ServerPerson>();
             
                case "Greater|Greater/Equals":
                    return (from person in CurrentDataSource where double.Parse(person.GetType().GetProperty(columnname).GetValue(person, null).ToString()) > double.Parse(values[0]) || double.Parse(person.GetType().GetProperty(columnname).GetValue(person, null).ToString()) >= double.Parse(values[1]) select person).ToList<ServerPerson>();
               
                case "Greater|Less":
                    return (from person in CurrentDataSource where double.Parse(person.GetType().GetProperty(columnname).GetValue(person, null).ToString()) > double.Parse(values[0]) || double.Parse(person.GetType().GetProperty(columnname).GetValue(person, null).ToString()) < double.Parse(values[1]) select person).ToList<ServerPerson>();
                       
                case "Greater|Less/Equals":
                    return (from person in CurrentDataSource where double.Parse(person.GetType().GetProperty(columnname).GetValue(person, null).ToString()) > double.Parse(values[0]) || double.Parse(person.GetType().GetProperty(columnname).GetValue(person, null).ToString()) <= double.Parse(values[1]) select person).ToList<ServerPerson>();
                   
                case "Greater|Not Equals":
                    return (from person in CurrentDataSource where double.Parse(person.GetType().GetProperty(columnname).GetValue(person, null).ToString()) > double.Parse(values[0]) || double.Parse(person.GetType().GetProperty(columnname).GetValue(person, null).ToString()) != double.Parse(values[1]) select person).ToList<ServerPerson>();

                      case "Greater/Equals|Greater/Equals":
                    return (from person in CurrentDataSource where double.Parse(person.GetType().GetProperty(columnname).GetValue(person, null).ToString()) >= double.Parse(values[0]) || double.Parse(person.GetType().GetProperty(columnname).GetValue(person, null).ToString()) >= double.Parse(values[1]) select person).ToList<ServerPerson>();
                   
                case "Greater/Less/Equals":
                    return (from person in CurrentDataSource where double.Parse(person.GetType().GetProperty(columnname).GetValue(person, null).ToString()) > double.Parse(values[0]) || double.Parse(person.GetType().GetProperty(columnname).GetValue(person, null).ToString()) <= double.Parse(values[1]) select person).ToList<ServerPerson>();
                  
                case "Greater/Equals|Less/Equals":
                    return (from person in CurrentDataSource where double.Parse(person.GetType().GetProperty(columnname).GetValue(person, null).ToString()) >= double.Parse(values[0]) || double.Parse(person.GetType().GetProperty(columnname).GetValue(person, null).ToString()) <= double.Parse(values[1]) select person).ToList<ServerPerson>();
                    
                case "Greater/Equals|Not Equals":
                    return (from person in CurrentDataSource where double.Parse(person.GetType().GetProperty(columnname).GetValue(person, null).ToString()) >= double.Parse(values[0]) || double.Parse(person.GetType().GetProperty(columnname).GetValue(person, null).ToString()) != double.Parse(values[1]) select person).ToList<ServerPerson>();
                    
                case "Less|Less":
                    return (from person in CurrentDataSource where double.Parse(person.GetType().GetProperty(columnname).GetValue(person, null).ToString()) <= double.Parse(values[0]) || double.Parse(person.GetType().GetProperty(columnname).GetValue(person, null).ToString()) < double.Parse(values[1]) select person).ToList<ServerPerson>();
             
                case "Less|Less/Equals":
                    return (from person in CurrentDataSource where double.Parse(person.GetType().GetProperty(columnname).GetValue(person, null).ToString()) < double.Parse(values[0]) || double.Parse(person.GetType().GetProperty(columnname).GetValue(person, null).ToString()) <= double.Parse(values[1]) select person).ToList<ServerPerson>();
                
                case "Less|Not Equals":
                    return (from person in CurrentDataSource where double.Parse(person.GetType().GetProperty(columnname).GetValue(person, null).ToString()) < double.Parse(values[0]) || double.Parse(person.GetType().GetProperty(columnname).GetValue(person, null).ToString()) != double.Parse(values[1]) select person).ToList<ServerPerson>();
                
                case "Less/Equals|Less/Equals":
                    return (from person in CurrentDataSource where double.Parse(person.GetType().GetProperty(columnname).GetValue(person, null).ToString()) <= double.Parse(values[0]) || double.Parse(person.GetType().GetProperty(columnname).GetValue(person, null).ToString()) <= double.Parse(values[1]) select person).ToList<ServerPerson>();

                case "Less/Equals|Not Equals":
                    return (from person in CurrentDataSource where double.Parse(person.GetType().GetProperty(columnname).GetValue(person, null).ToString()) <= double.Parse(values[0]) || double.Parse(person.GetType().GetProperty(columnname).GetValue(person, null).ToString()) != double.Parse(values[1]) select person).ToList<ServerPerson>();
                
                case "Not Equals|Not Equals":
                    return (from person in CurrentDataSource where double.Parse(person.GetType().GetProperty(columnname).GetValue(person, null).ToString()) != double.Parse(values[0]) || double.Parse(person.GetType().GetProperty(columnname).GetValue(person, null).ToString()) != double.Parse(values[1]) select person).ToList<ServerPerson>();
            
               }
            return null;
}

         [WebMethod]
        public List<ServerPerson> GetNumericFilteredDataFromServerAndComb(string FilterOperations, string filtervalues, string columnname)
        {
            string[] values = filtervalues.Split('|');

            switch (FilterOperations)
            {
                case "Equals|Equals":
                    return (from person in CurrentDataSource where double.Parse(person.GetType().GetProperty(columnname).GetValue(person, null).ToString()) == double.Parse(values[0]) && double.Parse(person.GetType().GetProperty(columnname).GetValue(person, null).ToString()) == double.Parse(values[1]) select person).ToList<ServerPerson>();

                case "Equals|Greater":
                    return (from person in CurrentDataSource where double.Parse(person.GetType().GetProperty(columnname).GetValue(person, null).ToString()) == double.Parse(values[0]) && double.Parse(person.GetType().GetProperty(columnname).GetValue(person, null).ToString()) > double.Parse(values[1]) select person).ToList<ServerPerson>();

                case "Equals|Greater/Equals":
                    return (from person in CurrentDataSource where double.Parse(person.GetType().GetProperty(columnname).GetValue(person, null).ToString()) == double.Parse(values[0]) && double.Parse(person.GetType().GetProperty(columnname).GetValue(person, null).ToString()) >= double.Parse(values[1]) select person).ToList<ServerPerson>();

                case "Equals|Less":
                    return (from person in CurrentDataSource where double.Parse(person.GetType().GetProperty(columnname).GetValue(person, null).ToString()) == double.Parse(values[0]) && double.Parse(person.GetType().GetProperty(columnname).GetValue(person, null).ToString()) < double.Parse(values[1]) select person).ToList<ServerPerson>();

                case "Equals|Less/Equals":
                    return (from person in CurrentDataSource where double.Parse(person.GetType().GetProperty(columnname).GetValue(person, null).ToString()) == double.Parse(values[0]) && double.Parse(person.GetType().GetProperty(columnname).GetValue(person, null).ToString()) <= double.Parse(values[1]) select person).ToList<ServerPerson>();

                case "Equals|Not Equals":
                    return (from person in CurrentDataSource where double.Parse(person.GetType().GetProperty(columnname).GetValue(person, null).ToString()) == double.Parse(values[0]) && double.Parse(person.GetType().GetProperty(columnname).GetValue(person, null).ToString()) != double.Parse(values[1]) select person).ToList<ServerPerson>();

                case "Greater|Greater":
                    return (from person in CurrentDataSource where double.Parse(person.GetType().GetProperty(columnname).GetValue(person, null).ToString()) > double.Parse(values[0]) && double.Parse(person.GetType().GetProperty(columnname).GetValue(person, null).ToString()) > double.Parse(values[1]) select person).ToList<ServerPerson>();

                case "Greater|Greater/Equals":
                    return (from person in CurrentDataSource where double.Parse(person.GetType().GetProperty(columnname).GetValue(person, null).ToString()) > double.Parse(values[0]) && double.Parse(person.GetType().GetProperty(columnname).GetValue(person, null).ToString()) >= double.Parse(values[1]) select person).ToList<ServerPerson>();

                case "Greater|Less":
                    return (from person in CurrentDataSource where double.Parse(person.GetType().GetProperty(columnname).GetValue(person, null).ToString()) > double.Parse(values[0]) && double.Parse(person.GetType().GetProperty(columnname).GetValue(person, null).ToString()) < double.Parse(values[1]) select person).ToList<ServerPerson>();

                case "Greater|Less/Equals":
                    return (from person in CurrentDataSource where double.Parse(person.GetType().GetProperty(columnname).GetValue(person, null).ToString()) > double.Parse(values[0]) && double.Parse(person.GetType().GetProperty(columnname).GetValue(person, null).ToString()) <= double.Parse(values[1]) select person).ToList<ServerPerson>();

                case "Greater|Not Equals":
                    return (from person in CurrentDataSource where double.Parse(person.GetType().GetProperty(columnname).GetValue(person, null).ToString()) > double.Parse(values[0]) && double.Parse(person.GetType().GetProperty(columnname).GetValue(person, null).ToString()) != double.Parse(values[1]) select person).ToList<ServerPerson>();

                case "Greater/Equals|Greater/Equals":
                    return (from person in CurrentDataSource where double.Parse(person.GetType().GetProperty(columnname).GetValue(person, null).ToString()) >= double.Parse(values[0]) && double.Parse(person.GetType().GetProperty(columnname).GetValue(person, null).ToString()) >= double.Parse(values[1]) select person).ToList<ServerPerson>();

                case "Greater/Less/Equals":
                    return (from person in CurrentDataSource where double.Parse(person.GetType().GetProperty(columnname).GetValue(person, null).ToString()) > double.Parse(values[0]) && double.Parse(person.GetType().GetProperty(columnname).GetValue(person, null).ToString()) <= double.Parse(values[1]) select person).ToList<ServerPerson>();

                case "Greater/Equals|Less/Equals":
                    return (from person in CurrentDataSource where double.Parse(person.GetType().GetProperty(columnname).GetValue(person, null).ToString()) >= double.Parse(values[0]) && double.Parse(person.GetType().GetProperty(columnname).GetValue(person, null).ToString()) <= double.Parse(values[1]) select person).ToList<ServerPerson>();

                case "Greater/Equals|Not Equals":
                    return (from person in CurrentDataSource where double.Parse(person.GetType().GetProperty(columnname).GetValue(person, null).ToString()) >= double.Parse(values[0]) && double.Parse(person.GetType().GetProperty(columnname).GetValue(person, null).ToString()) != double.Parse(values[1]) select person).ToList<ServerPerson>();

                case "Less|Less":
                    return (from person in CurrentDataSource where double.Parse(person.GetType().GetProperty(columnname).GetValue(person, null).ToString()) <= double.Parse(values[0]) && double.Parse(person.GetType().GetProperty(columnname).GetValue(person, null).ToString()) < double.Parse(values[1]) select person).ToList<ServerPerson>();

                case "Less|Less/Equals":
                    return (from person in CurrentDataSource where double.Parse(person.GetType().GetProperty(columnname).GetValue(person, null).ToString()) < double.Parse(values[0]) && double.Parse(person.GetType().GetProperty(columnname).GetValue(person, null).ToString()) <= double.Parse(values[1]) select person).ToList<ServerPerson>();

                case "Less|Not Equals":
                    return (from person in CurrentDataSource where double.Parse(person.GetType().GetProperty(columnname).GetValue(person, null).ToString()) < double.Parse(values[0]) && double.Parse(person.GetType().GetProperty(columnname).GetValue(person, null).ToString()) != double.Parse(values[1]) select person).ToList<ServerPerson>();

                case "Less/Equals|Less/Equals":
                    return (from person in CurrentDataSource where double.Parse(person.GetType().GetProperty(columnname).GetValue(person, null).ToString()) <= double.Parse(values[0]) && double.Parse(person.GetType().GetProperty(columnname).GetValue(person, null).ToString()) <= double.Parse(values[1]) select person).ToList<ServerPerson>();

                case "Less/Equals|Not Equals":
                    return (from person in CurrentDataSource where double.Parse(person.GetType().GetProperty(columnname).GetValue(person, null).ToString()) <= double.Parse(values[0]) && double.Parse(person.GetType().GetProperty(columnname).GetValue(person, null).ToString()) != double.Parse(values[1]) select person).ToList<ServerPerson>();

                case "Not Equals|Not Equals":
                    return (from person in CurrentDataSource where double.Parse(person.GetType().GetProperty(columnname).GetValue(person, null).ToString()) != double.Parse(values[0]) && double.Parse(person.GetType().GetProperty(columnname).GetValue(person, null).ToString()) != double.Parse(values[1]) select person).ToList<ServerPerson>();

            }
            return null;
    }
         [WebMethod]
        public List<ServerPerson> GetNumericFilteredDataFromServerNoComb(string FilterOperations, double filtervalue, string columnname)
        {
           

            switch (FilterOperations)
            {
                case "Equals":
                    return (from person in CurrentDataSource where double.Parse(person.GetType().GetProperty(columnname).GetValue(person, null).ToString()) == filtervalue select person).ToList<ServerPerson>();

                case "Greater":
                    return (from person in CurrentDataSource where double.Parse(person.GetType().GetProperty(columnname).GetValue(person, null).ToString()) > filtervalue select person).ToList<ServerPerson>();

                case "Greater/Equals":
                    return (from person in CurrentDataSource where double.Parse(person.GetType().GetProperty(columnname).GetValue(person, null).ToString()) >= filtervalue select person).ToList<ServerPerson>();

                case "Less":
                    return (from person in CurrentDataSource where double.Parse(person.GetType().GetProperty(columnname).GetValue(person, null).ToString()) < filtervalue select person).ToList<ServerPerson>();

                case "Less/Equals":
                    return (from person in CurrentDataSource where double.Parse(person.GetType().GetProperty(columnname).GetValue(person, null).ToString()) <= filtervalue select person).ToList<ServerPerson>();

                case "Not Equals":
                    return (from person in CurrentDataSource where double.Parse(person.GetType().GetProperty(columnname).GetValue(person, null).ToString()) != filtervalue select person).ToList<ServerPerson>();

            }
            return null;
      }



        [WebMethod]
        public List<ServerPerson> GetData(int startRow, int endRow)
        {
            List<ServerPerson> personList = new List<ServerPerson>();
            for (int i = startRow; i < endRow; i++)
            {
                personList.Add(CurrentDataSource[startRow]);
              
            }

            return personList;
        }
    }

    [DataContract]
    public class ServerPerson
    {
        public ServerPerson()
        {
        }

        public ServerPerson(int id)
        {

            Random _rnd = new Random();
            FirstName = DataGenerators.GetString(DataGenerators.GetFirstNames());
            LastName = DataGenerators.GetString(DataGenerators.GetLastNames());
            Age = _rnd.Next(20,70)+id; 
            Country = DataGenerators.GetString(DataGenerators.GetCountries());
        }
        private string _firstName;
        [DataMember]
        public string FirstName
        {
            get { return _firstName; }
            set { _firstName = value; }
        }

        private string _lastName;
        [DataMember]
        public string LastName
        {
            get { return _lastName; }
            set { _lastName = value; }
        }

        private int _age;
        [DataMember]
        public int Age
        {
            get { return _age; }
            set {
                if (value > 80)
                {
                    _age = value - 50;
                }
                else _age = value; 
            
            }
        }

        private string _country;
        [DataMember]
        public string Country
        {
            get { return _country; }
            set { _country = value; }
        }
    }

    public class DataGenerators
    {
        static Random _rnd = new Random();
        public static string[] _firstNames = "Andy|Ben|Charlie|Dan|Ed|Fred|Gil|Herb|Jack|Karl|Larry|Mark|Noah|Oprah|Paul|Quince|Rich|Steve|Ted|Ulrich|Vic|Xavier|Zeb".Split('|');
        static string[] _lastNames = "Ambers|Bishop|Cole|Danson|Evers|Frommer|Griswold|Heath|Jammers|Krause|Lehman|Myers|Neiman|Orsted|Paulson|Quaid|Richards|Stevens|Trask|Ulam".Split('|');
        static string[] _countries = "China|India|United States|Indonesia|Brazil|Pakistan|Bangladesh|Nigeria|Russia|Japan|Mexico|Philippines|Vietnam|Germany|Ethiopia|Egypt|Iran|Turkey|Congo|France|Thailand|United Kingdom|Italy|Myanmar".Split('|');

        public static string GetString(string[] arr)
        {
            return arr[_rnd.Next(arr.Length)];
        }
        public static string GetName()
        {
            return string.Format("{0} {1}", GetString(_firstNames), GetString(_lastNames));
        }

        // ** static list provider
        public static List<ServerPerson> GetCustomerList(int count)
        {
            var list = new List<ServerPerson>();
            for (int i = 0; i < count; i++)
            {
                list.Add(new ServerPerson(i));
            }
            return list;
        }

        // ** static value providers
        public static string[] GetCountries() { return _countries; }
        public static string[] GetFirstNames() { return _firstNames; }
        public static string[] GetLastNames() { return _lastNames; }

    }
}
