﻿using System;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Ink;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using System.Collections.ObjectModel;
using ServerSideFilteringSL.FilteringService;
using System.ServiceModel;
using C1.Silverlight;
using System.ComponentModel;

namespace ServerSideFilteringSL
{
    public class DataGridDataSource
    {
        

        private static ObservableCollection<ServerPerson> _people = new ObservableCollection<ServerPerson>();
        public static ObservableCollection<ServerPerson> DataSource { get; set; }
       
        public static ObservableCollection<ServerPerson> DefaultDataSource 
        {
            get
            {
                GetDefaultData();
               
                return _people;
            }
        }

        private  static void GetDefaultData()
        {
                int _pageSize = 50;
                DataWebServiceSoapClient proxy = new DataWebServiceSoapClient(new BasicHttpBinding(), new EndpointAddress(Extensions.GetAbsoluteUri("DataWebService.asmx")));
                proxy.GetCurrentDataSourceAsync(_pageSize);
             
                _people.Clear(); 
                 proxy.GetCurrentDataSourceCompleted+=((s,e)=>
                   {
                       foreach (ServerPerson person in e.Result)
                       {
                           _people.Add(person);
                       }
                   });
           
        }

           void proxy_GetCurrentDataSourceCompleted(object sender, GetCurrentDataSourceCompletedEventArgs e)
        {
            if (e.Result != null)
            {
                foreach (ServerPerson person in e.Result)
                {
                    _people.Add(person);
                }
            }
         }
    }
   
}
