﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using System.Collections.ObjectModel;
using ServerSideFilteringSL.FilteringService;
using System.ServiceModel;
using C1.Silverlight;
using C1.Silverlight.DataGrid;
using ServerSideFilteringSL.CustomFilters;
using System.Windows.Data;

namespace ServerSideFilteringSL
{
    public partial class MainPage : UserControl
    {
       
        DataWebServiceSoapClient proxy = new DataWebServiceSoapClient(new BasicHttpBinding(), new EndpointAddress(Extensions.GetAbsoluteUri("DataWebService.asmx")));
        public MainPage()
        {
            InitializeComponent();
            peopleDataGrid.CanUserAddRows = false;
            peopleDataGrid.CanUserEditRows = false;  
            peopleDataGrid.AutoGeneratingColumn += new EventHandler<C1.Silverlight.DataGrid.DataGridAutoGeneratingColumnEventArgs>(peopleDataGrid_AutoGeneratingColumn);  
        
            DataGridDataSource.DataSource = DataGridDataSource.DefaultDataSource;  
            peopleDataGrid.SetBinding(C1DataGrid.ItemsSourceProperty, new Binding() { Source = DataGridDataSource.DataSource});
         }

        void peopleDataGrid_AutoGeneratingColumn(object sender, C1.Silverlight.DataGrid.DataGridAutoGeneratingColumnEventArgs e)
        {
            if (e.Column  is DataGridTextColumn)
            e.Column.LoadingFilter += new C1.Silverlight.DataGrid.LoadingFilterEventHandler(TextColumn_LoadingFilter);
            if (e.Column is DataGridNumericColumn)
                e.Column.LoadingFilter += new C1.Silverlight.DataGrid.LoadingFilterEventHandler(NumericColumn_LoadingFilter);  
        }

        C1.Silverlight.DataGrid.IDataGridFilter NumericColumn_LoadingFilter(object sender, EventArgs e)
        {
            return new DataGridNumericServerFilter(sender as DataGridNumericColumn);
       }
        C1.Silverlight.DataGrid.IDataGridFilter TextColumn_LoadingFilter(object sender, EventArgs e)
        {
            return new DataGridTextServerFilter(sender as DataGridTextColumn);
        }

    
    }

  
}
